#ifndef _H_E8CD79BC25C827C5A1F10A780B70B376_Switches_DCPS_H_
#define _H_E8CD79BC25C827C5A1F10A780B70B376_Switches_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Switches_.h"


namespace raspimouse_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Switches_TypeSupportInterface;

            typedef Switches_TypeSupportInterface * Switches_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Switches_TypeSupportInterface> Switches_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Switches_TypeSupportInterface> Switches_TypeSupportInterface_out;


            class Switches_DataWriter;

            typedef Switches_DataWriter * Switches_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Switches_DataWriter> Switches_DataWriter_var;
            typedef DDS_DCPSInterface_out < Switches_DataWriter> Switches_DataWriter_out;


            class Switches_DataReader;

            typedef Switches_DataReader * Switches_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Switches_DataReader> Switches_DataReader_var;
            typedef DDS_DCPSInterface_out < Switches_DataReader> Switches_DataReader_out;


            class Switches_DataReaderView;

            typedef Switches_DataReaderView * Switches_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Switches_DataReaderView> Switches_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Switches_DataReaderView> Switches_DataReaderView_out;

            struct Switches_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Switches_, struct Switches_Seq_uniq_> Switches_Seq;
            typedef DDS_DCPSSequence_var < Switches_Seq> Switches_Seq_var;
            typedef DDS_DCPSSequence_out < Switches_Seq> Switches_Seq_out;

            class  Switches_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Switches_TypeSupportInterface_ptr _ptr_type;
                typedef Switches_TypeSupportInterface_var _var_type;

                static Switches_TypeSupportInterface_ptr _duplicate (Switches_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Switches_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Switches_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Switches_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Switches_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Switches_TypeSupportInterface () {};
                ~Switches_TypeSupportInterface () {};
            private:
                Switches_TypeSupportInterface (const Switches_TypeSupportInterface &);
                Switches_TypeSupportInterface & operator = (const Switches_TypeSupportInterface &);
            };

            class  Switches_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Switches_DataWriter_ptr _ptr_type;
                typedef Switches_DataWriter_var _var_type;

                static Switches_DataWriter_ptr _duplicate (Switches_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Switches_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Switches_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Switches_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Switches_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Switches_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Switches_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Switches_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Switches_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Switches_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Switches_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Switches_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Switches_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Switches_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Switches_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Switches_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Switches_& instance_data) = 0;

            protected:
                Switches_DataWriter () {};
                ~Switches_DataWriter () {};
            private:
                Switches_DataWriter (const Switches_DataWriter &);
                Switches_DataWriter & operator = (const Switches_DataWriter &);
            };

            class  Switches_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Switches_DataReader_ptr _ptr_type;
                typedef Switches_DataReader_var _var_type;

                static Switches_DataReader_ptr _duplicate (Switches_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Switches_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Switches_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Switches_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Switches_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Switches_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Switches_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Switches_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Switches_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Switches_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Switches_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Switches_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Switches_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Switches_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Switches_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Switches_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Switches_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Switches_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Switches_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Switches_& instance) = 0;

            protected:
                Switches_DataReader () {};
                ~Switches_DataReader () {};
            private:
                Switches_DataReader (const Switches_DataReader &);
                Switches_DataReader & operator = (const Switches_DataReader &);
            };

            class  Switches_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Switches_DataReaderView_ptr _ptr_type;
                typedef Switches_DataReaderView_var _var_type;

                static Switches_DataReaderView_ptr _duplicate (Switches_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Switches_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Switches_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Switches_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Switches_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Switches_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Switches_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Switches_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Switches_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Switches_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Switches_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Switches_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Switches_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Switches_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Switches_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Switches_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Switches_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Switches_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Switches_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Switches_& instance) = 0;

            protected:
                Switches_DataReaderView () {};
                ~Switches_DataReaderView () {};
            private:
                Switches_DataReaderView (const Switches_DataReaderView &);
                Switches_DataReaderView & operator = (const Switches_DataReaderView &);
            };
        }

    }

}

#endif
